// CpuDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Peltier.h"
#include "CpuDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCpuDlg dialog


CCpuDlg::CCpuDlg (CWnd* pParent /*=NULL*/)
	: CTabPageSSL (CCpuDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCpuDlg)
	m_cpu_radio = 0;
	m_default_power = 0.0f;
	m_default_speed = 0.0f;
	m_default_voltage = 0.0f;
	m_overclocked_power = 0.0f;
	m_overclocked_speed = 0.0f;
	m_overclocked_voltage = 0.0f;
	m_messages = _T("");
	//}}AFX_DATA_INIT
}


void CCpuDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCpuDlg)
	DDX_Radio(pDX, IDC_DRADIO, m_cpu_radio);
	DDX_Text(pDX, IDC_DPOWER, m_default_power);
	DDX_Text(pDX, IDC_DSPEED, m_default_speed);
	DDX_Text(pDX, IDC_DVOLT, m_default_voltage);
	DDX_Text(pDX, IDC_OPOWER, m_overclocked_power);
	DDX_Text(pDX, IDC_OSPEED, m_overclocked_speed);
	DDX_Text(pDX, IDC_OVOLT, m_overclocked_voltage);
	DDX_Text(pDX, IDC_MESSAGES, m_messages);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCpuDlg, CDialog)
	//{{AFX_MSG_MAP(CCpuDlg)
	ON_BN_CLICKED(IDC_DRADIO, OnDradio)
	ON_BN_CLICKED(IDC_ORADIO, OnDradio)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCpuDlg message handlers

void CCpuDlg::OnDradio() 
{
	UpdateData(TRUE);

	switch(m_cpu_radio)
	{

	case 0:
		GetDlgItem(IDC_OSPEED) -> EnableWindow(FALSE);
		GetDlgItem(IDC_OVOLT) -> EnableWindow(FALSE);

		GetDlgItem(IDC_DSPEED) -> SetFocus();

		m_overclocked_speed = 0;
		m_overclocked_voltage = 0;
		m_overclocked_power = 0;

		break;

	default:
		GetDlgItem(IDC_OSPEED) -> EnableWindow(TRUE);
		GetDlgItem(IDC_OVOLT) -> EnableWindow(TRUE);

		GetDlgItem(IDC_OSPEED) -> SetFocus();

		break;
	}

	UpdateData(FALSE);
}

void CCpuDlg::OnPcalc() 
{
	UpdateData(TRUE);

	if(m_cpu_radio == 0)
	{
		m_power = m_default_power;
		return;
	}

	if((m_default_voltage ==0) || (m_default_speed == 0))
	{
		m_messages = "Calculation failed. Please enter non-zero values for default core speed and voltage.";
		UpdateData(FALSE);
		return;
	}

	m_overclocked_power = m_default_power * (m_overclocked_speed / m_default_speed) * ((m_overclocked_voltage * m_overclocked_voltage) / (m_default_voltage * m_default_voltage));
	m_power = m_overclocked_power;

	if(m_overclocked_speed < m_default_speed)
	{
		m_messages = "Underclocked power output calculated sucessfully.";
	}
	else
	{
		m_messages = "Overclocked power output calculated successfully.";
	}

	UpdateData(FALSE);
}
