// PeltDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Peltier.h"
#include "PeltDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPeltDlg dialog


CPeltDlg::CPeltDlg (CWnd* pParent /*=NULL*/)
	: CTabPageSSL (CPeltDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPeltDlg)
	m_dtmax = 0.0f;
	m_i = 0.0f;
	m_imax = 0.0f;
	m_qmax = 0.0f;
	m_v = 0.0f;
	m_vmax = 0.0f;
	m_pelts = 1.0f;
	m_messages = _T("");
	m_pelt_radio = 0;
	//}}AFX_DATA_INIT
}


void CPeltDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPeltDlg)
	DDX_Control(pDX, IDC_SPIN1, m_spin);
	DDX_Text(pDX, IDC_DTMAX, m_dtmax);
	DDX_Text(pDX, IDC_I, m_i);
	DDX_Text(pDX, IDC_IMAX, m_imax);
	DDX_Text(pDX, IDC_QMAX, m_qmax);
	DDX_Text(pDX, IDC_V, m_v);
	DDX_Text(pDX, IDC_VMAX, m_vmax);
	DDX_Text(pDX, IDC_PELTS, m_pelts);
	DDX_Text(pDX, IDC_MESSAGES, m_messages);
	DDX_Radio(pDX, IDC_SPECS_RADIO, m_pelt_radio);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPeltDlg, CDialog)
	//{{AFX_MSG_MAP(CPeltDlg)
	ON_BN_CLICKED(IDC_I_RADIO, OnIRadio)
	ON_BN_CLICKED(IDC_V_RADIO, OnIRadio)
	ON_BN_CLICKED(IDC_SPECS_RADIO, OnIRadio)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPeltDlg message handlers

void CPeltDlg::OnIRadio() 
{
	UpdateData(TRUE);

	switch(m_pelt_radio)
	{

	case 1:
		GetDlgItem(IDC_I) -> EnableWindow(TRUE);
		GetDlgItem(IDC_V) -> EnableWindow(FALSE);

		GetDlgItem(IDC_I) -> SetFocus();

		m_v = 0;

		m_messages = "Powering a Peltier from anything other than Imax/Vmax will use an approximate formula.";
		break;

	case 2:
		GetDlgItem(IDC_I) -> EnableWindow(FALSE);
		GetDlgItem(IDC_V) -> EnableWindow(TRUE);

		GetDlgItem(IDC_V) -> SetFocus();

		m_i = 0;

		m_messages = "Powering a Peltier from anything other than Imax/Vmax will use an approximate formula.";
		break;

	default:
		GetDlgItem(IDC_I) -> EnableWindow(FALSE);
		GetDlgItem(IDC_V) -> EnableWindow(FALSE);

		GetDlgItem(IDC_IMAX) -> SetFocus();

		m_i = 0;
		m_v = 0;

		break;
	}

	UpdateData(FALSE);
}

void CPeltDlg::OnPeltCalc() 
{
	UpdateData(TRUE);

	switch(m_pelt_radio)
	{
		case 1:
			if(m_imax > 0)
			{
				m_v = (m_i / m_imax) * m_vmax;
			}

			if (m_i > m_imax)
			{
				m_messages = "You have specified a current higher than Imax. This may damage the Peltier.";
			}
			break;

		case 2:
			if(m_vmax > 0)
			{
				m_i = (m_v / m_vmax) * m_imax;
			}

			if (m_v > m_vmax)
			{
				m_messages = "You have specified a voltage higher than Vmax. This may damage the Peltier.";
			}
			else
			{
				m_messages = "Please note that since a Peltiers resistance is variable, specifying V gives less accurate answers than specifying I.";
			}
			break;

		default:
			break;
	}

	UpdateData(FALSE);	
}
