// PeltierDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Peltier.h"
#include "PeltierDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPeltierDlg dialog

CPeltierDlg::CPeltierDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPeltierDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPeltierDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPeltierDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPeltierDlg)
	DDX_Control(pDX, IDC_TAB1, m_tab);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPeltierDlg, CDialog)
	//{{AFX_MSG_MAP(CPeltierDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDCALC, OnCalc)
	ON_BN_CLICKED(IDC_RESULTS, OnResults)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_USER+1, OnCloseResults)
	ON_NOTIFY_EX(TTN_NEEDTEXT, 0, OnToolTip)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPeltierDlg message handlers

//Define a pointer to the results dialog
CResultsDlg* g_pResults = NULL;

BOOL CPeltierDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Tab setup.
	int nPageID = 0;

	m_cpu_tab.Create (IDD_CPU, this);
	m_tab.AddSSLPage (_T("CPU"), nPageID++, &m_cpu_tab);

	m_cold_tab.Create (IDD_COLD, this);
	m_tab.AddSSLPage (_T("Cold plate"), nPageID++, &m_cold_tab);

	m_pelt_tab.Create (IDD_PELT, this);
	m_tab.AddSSLPage (_T("Peltier"), nPageID++, &m_pelt_tab);

	m_cooler_tab.Create (IDD_COOLER, this);
	m_tab.AddSSLPage (_T("Cooler"), nPageID++, &m_cooler_tab);

	m_misc_tab.Create (IDD_MISC, this);
	m_tab.AddSSLPage (_T("Miscellaneous"), nPageID++, &m_misc_tab);

	//Setup spin control for number of Peltiers. 32 just seems a sensible number, although there is no reason why more could not be used.
	m_pelt_tab.m_spin.SetRange(1, 32);

	//Enable tooltips (obviously).
	EnableToolTips();
	m_cpu_tab.EnableToolTips();
	m_cold_tab.EnableToolTips();
	m_pelt_tab.EnableToolTips();
	m_cooler_tab.EnableToolTips();
	m_misc_tab.EnableToolTips();

	//Open the results dialog, but hide it.
	if(!g_pResults)
		{
			g_pResults = new CResultsDlg(this);
			g_pResults -> m_pParent = this;
			g_pResults -> ShowWindow(SW_HIDE);
		}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPeltierDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPeltierDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPeltierDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPeltierDlg::OnCalc() 
{
	//Some temprorary variables.
	float temp;
	float temp2;
	float last_calc = m_misc_tab.m_ambient_temperature;
	float new_power;
	int loops = 0;

/*I have used the following procedure to calculate the four important temperatures:
ambient, Peltier hot side, Peltier cold side and CPU temperature.

1) Ambient temperature is already given by user.

2) Add electrical power from Peltier to total heat output from CPU (this will include heat
leaking in from outside when I get around to adding that feature) and multiply by the
cooler's thermal resistance. This gives Peltier hot side temperature.

3) Use Peltier performance formula to calculate DT, and thus cold side temperature.

4) Multiply heat output from CPU by cold plate thermal resistance to get CPU temperature.*/

	//Get all the data.
	m_cpu_tab.UpdateData(TRUE);
	m_cold_tab.UpdateData(TRUE);
	m_pelt_tab.UpdateData(TRUE);
	m_cooler_tab.UpdateData(TRUE);
	m_misc_tab.UpdateData(TRUE);

	//Ambient temperature is easy to calculate!
	g_pResults -> m_ambient_temperature = m_misc_tab.m_ambient_temperature;

	//Do the individual tab's calculations now.
	if(m_cooler_tab.m_cooler_radio == 1)
	{
		m_cooler_tab.OnCalcr();
	}

	if(m_cold_tab.m_cold_radio == 1)
	{
		m_cold_tab.OnCalcr();
	}

	if(m_pelt_tab.m_pelt_radio != 0)
	{
		m_pelt_tab.OnPeltCalc();
	}

	m_cpu_tab.OnPcalc();

	//initialise CPU temp so that the following loop works properly.
	g_pResults -> m_cpu_temperature = m_misc_tab.m_ambient_temperature;

	do
	{
		last_calc = g_pResults -> m_cpu_temperature;

		//Correct CPU output power to include heat leaked in through insulation.
		if(m_misc_tab.m_insulation)
		{
			new_power = m_cpu_tab.m_power + (m_misc_tab.m_ambient_temperature - g_pResults -> m_cpu_temperature) / m_misc_tab.m_insulation;
		}
		else
		{
			new_power = m_cpu_tab.m_power;
		}

		//Hot side temperature.

		//Electrical power used by Peltier.
		float hot_side_power;
		switch(m_pelt_tab.m_pelt_radio)
		{
			case 0:
				hot_side_power = m_pelt_tab.m_imax * m_pelt_tab.m_vmax * m_pelt_tab.m_pelts;
				break;

			default:
				hot_side_power = m_pelt_tab.m_i * m_pelt_tab.m_v * m_pelt_tab.m_pelts;
				break;
		}

		//Power out fom CPU.
		hot_side_power += new_power;

		//Now the hot side temperature can be calculated.
		g_pResults -> m_hot_side_temperature = (hot_side_power * m_cooler_tab.m_thermal_resistance) + m_misc_tab.m_ambient_temperature;

		//Calculate cold side temperature.
		switch(m_pelt_tab.m_pelt_radio)
		{
			//Default values for Peltier, so use exact formula: DT/DTmax = 1 - Q/Qmax
			case 0:
				g_pResults -> m_cold_side_temperature = g_pResults -> m_hot_side_temperature - m_pelt_tab.m_dtmax * (1 - ((new_power / m_pelt_tab.m_pelts) / m_pelt_tab.m_qmax));
				break;

			//Custom values for I and V, so use approximate formula: DT/DTmax = (2I/Imax) - (I/Imax)^2)^0.8 - ((Q / Qmax) / (I/Imax)^0.2)
			default:
				//I think I'll split this one up into steps or it will be enormous...

				temp = (2 * (m_pelt_tab.m_i / m_pelt_tab.m_imax)) - ((m_pelt_tab.m_i / m_pelt_tab.m_imax) * (m_pelt_tab.m_i / m_pelt_tab.m_imax));
				temp = pow(temp, 0.8f);

				temp2 = (m_pelt_tab.m_i / m_pelt_tab.m_imax);
				temp2 = pow(temp2, 0.2);
				temp2 = (m_cpu_tab.m_power / m_pelt_tab.m_pelts) / (m_pelt_tab.m_qmax * temp2);

				temp = m_pelt_tab.m_dtmax * (temp - temp2);

				g_pResults -> m_cold_side_temperature = g_pResults -> m_hot_side_temperature - temp;
				break;
		}

		//The last step: Calculate CPU temperature.
		g_pResults -> m_cpu_temperature = g_pResults -> m_cold_side_temperature + (new_power * m_cold_tab.m_thermal_resistance);

		//Make sure that the loop ends if it doesn't converge quickly enough.
		loops++;
		if(loops > 100000) break;

	}while(fabs(last_calc - g_pResults -> m_cpu_temperature) > 0.00001);

	//Show the results.
	g_pResults -> UpdateData(FALSE);
}

void CPeltierDlg::OnResults() 
{
	//If tick box is checked, show results dialog and calculate results.
	CButton* pTemp = (CButton*) GetDlgItem(IDC_RESULTS);
	if(pTemp -> GetCheck())
	{
		g_pResults -> ShowWindow(SW_SHOW);
		OnCalc();
	}
	else
	{
		g_pResults -> ShowWindow(SW_HIDE);
	}
}

void CPeltierDlg::OnCloseResults()
{
	//Close the results dialog.
	if(g_pResults)
		{
			delete g_pResults;
			g_pResults = NULL;
		}
}

//This displays the correct text for each tooltip.
BOOL CPeltierDlg::OnToolTip(UINT id, NMHDR* pNMHDR, LRESULT* pResult)
{
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    UINT nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)
    {
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);
        if(nID)
        {
            pTTT->lpszText = MAKEINTRESOURCE(nID);
            pTTT->hinst = AfxGetResourceHandle();
            return(TRUE);
        }
    }
    return(FALSE);
}

void CPeltierDlg::OnClose() 
{
	OnCloseResults();	
	CDialog::OnClose();
}
